function updateSpawnController()
	addMissingEnemies()
	despawnDistantEnemies()
	addBlackholes()
end

function addMissingEnemies()
	while getTableCount(enemies) < desiredEnemyCount do
		local angle = math.rad(math.random(0,36000)/100)
		local dist = math.random(800,1000)
		local enemyType = 0
		local rand = math.random(0,1000000)/1000000
		if gameTimer > 30 then
			gameTimer = 0
			desiredEnemyCount = desiredEnemyCount + 60
			rand2 = math.random(1,7)
			
			
		end
		--set spawn pattern
			if rand2 == 1 then
				if rand < 0.9 then	--asteroid
					enemyType = 0
				elseif rand < 1 then	--explosive asteroid
					enemyType = 2
				end
			elseif rand2 == 2 then
				if rand < 0.93 then	--asteroid
					enemyType = 0
				elseif rand < 0.96 then	--explosive asteroid
					enemyType = 2
				elseif rand < 0.975 then	--hunter
					enemyType = 3
				elseif rand < 0.985 then	--mine
					enemyType = 4
				elseif rand < 1 then	--fighter
					enemyType = 1
				end
			elseif rand2 == 3 then
				if rand < 0.92 then	--asteroid
					enemyType = 0
				elseif rand < 0.94 then	--explosive asteroid
					enemyType = 2
				elseif rand < 0.97 then	--hunter
					enemyType = 3
				elseif rand < 1 then	--fighter
					enemyType = 1
				end
			elseif rand2 == 4 then
				if rand < 0.93 then	--asteroid
					enemyType = 0
				elseif rand < 0.985 then	--mine
					enemyType = 4
				elseif rand < 1 then	--fighter
					enemyType = 1
				end
			elseif rand2 == 5 then
				if rand < 0.95 then	--asteroid
					enemyType = 0
				elseif rand < 1 then	--hunter
					enemyType = 3
				end
			elseif rand2 == 6 then
				if rand < 0.93 then	--asteroid
					enemyType = 0
				elseif rand < 0.96 then	--explosive asteroid
					enemyType = 2
				elseif rand < 0.965 then	--hunter
					enemyType = 3
				elseif rand < 0.975 then	--mine
					enemyType = 4
				elseif rand < 1 then	--fighter
					enemyType = 1
				end
			end
		
		newEnemy = {x = player.x+math.cos(angle)*dist,y = player.y+math.sin(angle)*dist,eType = enemyType, id = math.random(1,10^21), rot = 0, dir = -angle, velocity = math.random(20,60)} table.insert(enemies,newEnemy)
	end
end

function despawnDistantEnemies()
	for i, enemy in ipairs(enemies) do
		if getDistance(enemy.x,enemy.y,player.x,player.y) > 1000 then
			table.remove(enemies,i)
		end
	end
end

function addBlackholes()
	if getTableCount(blackholes) < desiredEnemyCount/5 then
		newHole = {x = math.random(PA.x,PA.x+PA.w),y = math.random(PA.y,PA.y+PA.h),radius = math.random(100,250)} table.insert(blackholes,newHole)
	end
end