function updateMenu()
	updateButtons()
end

function love.mousereleased( x, y, button, istouch )
	m1Released = false
	if button == '1' then
		m1Released = true
	end
end

function updateButtons()
	for i, button in ipairs(buttons) do
		if button.isControls then else
			if button.active then
				--set button functions
				if button.id == 0 then	--quit
					exitGame()
				elseif button.id == 1 then	--play
					gamestate = 'playing'
					playerRespawn()
				elseif button.id == 2 then	--goto settings
					gamestate = 'settings'
					menuStarAngle = math.rad(math.random(0,360))	--change the movement of the stars in the menus
				elseif button.id == 3 then	--return to mainmenu from settings
					gamestate = 'menu'
					menuStarAngle = math.rad(math.random(0,360))	--change the movement of the stars in the menus
				elseif button.id == 4 then	--fullscreen on
					settings.fullscreen = true
					love.window.setFullscreen(settings.fullscreen)
				elseif button.id == 5 then	--fullscreen off
					settings.fullscreen = false
					love.window.setFullscreen(settings.fullscreen)
				elseif button.id == 6 then --simplePlayer off
					settings.simplePlayer = false
					settings.secretPlayer = false
				elseif button.id == 7 then --simplePlayer on
					settings.simplePlayer = true
					settings.secretPlayer = false
				elseif button.id == 69 then	--secre player on
					settings.secretPlayer = true
				end
			end
			
			--deactivate all buttons
			button.active = false
		end
		--rebind stuff
		if button.isHover then
			function love.keypressed( key, scancode, isrepeat )
				if button.id == 8 then
					controls.turnLeft = scancode
				elseif button.id == 9 then
					controls.turnRight = scancode
				elseif button.id == 10 then
					controls.accelerate = scancode
				elseif button.id == 11 then
					controls.fire = scancode
				end
				--save controls
				saveData.save(controls,"controls")
			end
		end
		
		
	end
end