function drawBG()
	if gamestate == 'playing' then lg.setBackgroundColor(qColor.r,qColor.g,qColor.b) else lg.setBackgroundColor(0,0,0) end
	drawStars()
	drawPlayableArea()
	moveStarsIfInMenu()
end

function drawStars()
	--add stars
	if getTableCount(stars) == 0 then
		distributeStars()
	end
	
	for i, star in ipairs(stars) do
		if star.x > -1 and star.x < 641 and star.y > -1 and star.y < 361 then
			--draw the fuckers
			if gamestate == 'playing' then
				lg.setColor(pColor.r*1.25*star.dist+50,pColor.g*1.25*star.dist+50,pColor.b*1.25*star.dist+50)
			else
				lg.setColor(255*star.dist+50,255*star.dist+50,255*star.dist+50)
			end
			lg.circle('fill',star.x,star.y,0.75)
		end
	end
	
	
end

function distributeStars()
	for n=1,1.5*10^5 do
		newStar = {x = math.random(-4080,4080),y = math.random(-4080,4080),dist = math.random(8000,0)/10000} table.insert(stars,newStar)
		n = n - 1
	end
	
end

function drawPlayableArea()
	lg.setColor(10,10,10,255/1.2)
	lg.rectangle('fill',PA.x-40800,PA.y-40800,PA.w+(40800*2),40800)
	lg.rectangle('fill',PA.x-40800,PA.y+PA.h,PA.w+(40800*2),40800*2)
	lg.rectangle('fill',PA.x+PA.w,PA.y,(40800*2),PA.h)
	lg.rectangle('fill',PA.x-(40800),PA.y,(40800),PA.h)
	lg.setColor(pColor.r,pColor.g,pColor.b)
	lg.rectangle('line',PA.x,PA.y,PA.w,PA.h)
end

function moveStarsIfInMenu()
	if gamestate == 'playing' then else
		--set vector
		local angle = menuStarAngle
		local speed = 10
		
		--move the fuckers
		for i, star in ipairs(stars) do
			star.x = star.x + (math.cos(angle)*speed*star.dist*hdt)
			star.y = star.y + (math.sin(angle)*speed*star.dist*hdt)
		end
		
	end
end