function drawBlackholes()
	drawBlackHoleVortex()
	drawBlackHoleCore()
end

function drawBlackHoleVortex()
	for i, blackhole in ipairs(blackholes) do
		if blackhole.x > -blackhole.radius and blackhole.x < 640+blackhole.radius and blackhole.y > - blackhole.radius and blackhole.y < 360+blackhole.radius then
			lg.setColor(tColor.r,tColor.g,tColor.b,255/8)
			lg.draw(i_blackholeVortex,blackhole.x,blackhole.y,math.rad(globalTimer*360),blackhole.radius/i_blackholeVortex:getWidth()*2*1,blackhole.radius/i_blackholeVortex:getWidth()*1,i_blackholeVortex:getWidth()/2,i_blackholeVortex:getHeight()/2)
			lg.draw(i_blackholeVortex,blackhole.x,blackhole.y,math.rad(globalTimer*360),blackhole.radius/i_blackholeVortex:getWidth()*2*0.8,blackhole.radius/i_blackholeVortex:getWidth()*2*0.8,i_blackholeVortex:getWidth()/2,i_blackholeVortex:getHeight()/2)
			lg.draw(i_blackholeVortex,blackhole.x,blackhole.y,math.rad(globalTimer*360),blackhole.radius/i_blackholeVortex:getWidth()*2*0.6,blackhole.radius/i_blackholeVortex:getWidth()*2*0.6,i_blackholeVortex:getWidth()/2,i_blackholeVortex:getHeight()/2)
			lg.draw(i_blackholeVortex,blackhole.x,blackhole.y,math.rad(globalTimer*360),blackhole.radius/i_blackholeVortex:getWidth()*2*0.4,blackhole.radius/i_blackholeVortex:getWidth()*2*0.4,i_blackholeVortex:getWidth()/2,i_blackholeVortex:getHeight()/2)
			lg.draw(i_blackholeVortex,blackhole.x,blackhole.y,math.rad(globalTimer*360),blackhole.radius/i_blackholeVortex:getWidth()*2*0.2,blackhole.radius/i_blackholeVortex:getWidth()*2*0.2,i_blackholeVortex:getWidth()/2,i_blackholeVortex:getHeight()/2)
			lg.setColor(tColor.r,tColor.g,tColor.b,255/16)
			lg.draw(i_blackholeVortex,blackhole.x,blackhole.y,math.rad(-globalTimer*360),blackhole.radius/i_blackholeVortex:getWidth()*2*1,blackhole.radius/i_blackholeVortex:getWidth()*1,i_blackholeVortex:getWidth()/2,i_blackholeVortex:getHeight()/2)
			lg.draw(i_blackholeVortex,blackhole.x,blackhole.y,math.rad(-globalTimer*360),blackhole.radius/i_blackholeVortex:getWidth()*2*0.8,blackhole.radius/i_blackholeVortex:getWidth()*2*0.8,i_blackholeVortex:getWidth()/2,i_blackholeVortex:getHeight()/2)
			lg.draw(i_blackholeVortex,blackhole.x,blackhole.y,math.rad(-globalTimer*360),blackhole.radius/i_blackholeVortex:getWidth()*2*0.6,blackhole.radius/i_blackholeVortex:getWidth()*2*0.6,i_blackholeVortex:getWidth()/2,i_blackholeVortex:getHeight()/2)
			lg.draw(i_blackholeVortex,blackhole.x,blackhole.y,math.rad(-globalTimer*360),blackhole.radius/i_blackholeVortex:getWidth()*2*0.4,blackhole.radius/i_blackholeVortex:getWidth()*2*0.4,i_blackholeVortex:getWidth()/2,i_blackholeVortex:getHeight()/2)
			lg.draw(i_blackholeVortex,blackhole.x,blackhole.y,math.rad(-globalTimer*360),blackhole.radius/i_blackholeVortex:getWidth()*2*0.2,blackhole.radius/i_blackholeVortex:getWidth()*2*0.2,i_blackholeVortex:getWidth()/2,i_blackholeVortex:getHeight()/2)
		end
	end
end

function drawBlackHoleCore()
	for i, blackhole in ipairs(blackholes) do
		lg.setColor(pColor.r,pColor.g,pColor.b,255/3*(30-blackhole.timer))
		lg.draw(i_blackhole,blackhole.x,blackhole.y,math.rad(globalTimer*720),0.3,0.3,i_blackhole:getWidth()/2,i_blackhole:getHeight()/2)
		lg.draw(i_blackhole,blackhole.x,blackhole.y,math.rad(-globalTimer*1080+180),0.3,0.3,i_blackhole:getWidth()/2,i_blackhole:getHeight()/2)
	end
end