function drawMenu()
	drawMenuLogo()
	drawButtons()
	drawCursor()
end

function drawMenuLogo()
	lg.setColor(255,255,255)
	lg.draw(i_logo,640/2,75, 0, 3,3, i_logo:getWidth()/2,i_logo:getHeight()/2)
	--remove all screenshake
	shake = 0
end

function drawButtons()
	for i, button in ipairs(buttons) do
		if button.state == gamestate then
			--set color based if hover
			if collision(mouse.x/2,mouse.y/2,0.01,0.01, button.x-(button.img:getWidth()/2*button.scale),button.y-(button.img:getHeight()/2*button.scale),button.img:getWidth()*button.scale,button.img:getHeight()*button.scale) then
				lg.setColor(247,237,147)
				--activate buttons
				if lm.isDown('1') then
					button.active = true
				end
			else
				lg.setColor(87,61,217)
			end
			--draw the button
			lg.draw(button.img,button.x,button.y, 0, button.scale,button.scale, button.img:getWidth()/2,button.img:getHeight()/2)
		end
	end
end

function drawCursor()
	lg.setColor(0,0,0,255/3*2)
	lg.draw(i_cursor,math.floor(mouse.x/2)+2,math.floor(mouse.y/2)+3, 0, 1,1, i_cursor:getWidth()/2,i_cursor:getHeight()/2)
	lg.setColor(255,255,255)
	lg.draw(i_cursor,math.floor(mouse.x/2),math.floor(mouse.y/2), 0, 1,1, i_cursor:getWidth()/2,i_cursor:getHeight()/2)
end